/// <reference types="node" />
/// <reference types="@constl/orbit-db-types" />
import { type AccessController, type Identity, type Storage } from "@orbitdb/core";
import type { Helia } from "helia";
export type OrderedKeyValueDatabaseType = Awaited<ReturnType<ReturnType<typeof OrderedKeyValue>>>;
declare const OrderedKeyValue: {
    (): ({ ipfs, identity, address, name, access, directory, meta, headsStorage, entryStorage, indexStorage, referencesCount, syncAutomatically, onUpdate, }: {
        ipfs: Helia;
        identity?: Identity;
        address: string;
        name?: string;
        access?: AccessController;
        directory?: string;
        meta?: object;
        headsStorage?: Storage;
        entryStorage?: Storage;
        indexStorage?: Storage;
        referencesCount?: number;
        syncAutomatically?: boolean;
        onUpdate?: () => void;
    }) => Promise<{
        type: "ordered-keyvalue";
        put: (key: string, value: unknown, position?: number) => Promise<string>;
        set: (key: string, value: unknown, position?: number) => Promise<string>;
        del: (key: string) => Promise<string>;
        move: (key: string, position: number) => Promise<string>;
        get: (key: string) => Promise<{
            value: unknown;
            position?: number;
        } | undefined>;
        iterator: ({ amount, }?: {
            amount?: number;
        }) => AsyncGenerator<{
            key: string;
            value: unknown;
            position: number;
            hash: string;
        }, void, unknown>;
        all: () => Promise<{
            key: string;
            value: unknown;
            hash: string;
        }[]>;
        addOperation: (args: {
            op: string;
            key: string;
            value: unknown;
        }) => Promise<string>;
        address: string;
        close(): Promise<void>;
        drop(): Promise<void>;
        events: import("events");
        access: AccessController;
        log: import("@orbitdb/core").Log;
    }>;
    type: "ordered-keyvalue";
};
export default OrderedKeyValue;
